function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Copyright 2021 Tridium, Inc. All Rights Reserved.
 */

/* eslint-env browser */

/* global niagara */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/HyperlinkListSelectorV1
 */
define(['baja!', 'baja!bajaui:Align,gx:Brush,gx:Font,bajaui:Halign,bajaui:HyperlinkMode,' + 'gx:Insets,bajaui:Valign,gx:Size,baja:VirtualComponent', 'bajaux/spandrel', 'Promise', 'nmodule/webEditors/rc/wb/profile/profileUtils', 'nmodule/bajaui/rc/util/pxUtils', 'log!uxMedia', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, types, spandrel, Promise, profileUtils, pxUtils, log) {
  'use strict';

  var logSevere = log.severe.bind(log);

  var widgetDefaults = function widgetDefaults() {
    return {
      properties: {
        rootCssClass: 'ux-HyperlinkListSelector',
        enabled: true,
        visible: true,
        font: baja.$('gx:Font', 'null'),
        background: baja.$('gx:Brush', 'null'),
        align: baja.$('bajaui:Halign', 'left'),
        rowAlign: baja.$('bajaui:Valign', 'center'),
        browserTarget: '_self',
        selectionText: 'Select Hyperlink',
        wbTarget: baja.$('bajaui:HyperlinkMode', 'replace')
      }
    };
  };
  /**
   * HyperlinkListSelectorV1 is a Widget for vykonPro:HyperlinkListSelectorV1.
   *
   * @class
   * @alias module:nmodule/vykonPro/rc/HyperlinkListSelectorV1
   * @extends {module:bajaux/Widget}
   */


  return /*#__PURE__*/function (_spandrel) {
    _inherits(HyperlinkListSelector, _spandrel);

    var _super = _createSuper(HyperlinkListSelector);

    function HyperlinkListSelector(params) {
      _classCallCheck(this, HyperlinkListSelector);

      return _super.call(this, {
        params: params,
        defaults: widgetDefaults()
      });
    }

    _createClass(HyperlinkListSelector, [{
      key: "doInitialize",
      value: function doInitialize(dom) {
        var _this = this;

        dom.on('change', '.-v-Selector', function (e) {
          hyper(e.target.value, _this);
        });
      }
    }]);

    return HyperlinkListSelector;
  }(spandrel(function (model, _ref) {
    var properties = _ref.properties,
        rootElement = _ref.rootElement;
    var background = properties.background,
        font = properties.font,
        align = properties.align,
        rowAlign = properties.rowAlign,
        ord = properties.ord,
        selectionText = properties.selectionText;

    if (ord.isNull()) {
      return;
    }

    var sub = new baja.Subscriber();
    var baseOrd = baja.Ord.make({
      base: profileUtils.getCurrentOrd().relativizeToSession(),
      child: ord
    }).normalize();
    return baseOrd.get({
      subscriber: sub
    }).then(function (comp) {
      var hls = rootElement;
      background.applyBackgroundToElement(hls);
      hls.style.justifyContent = toHAlign(align.getTag());
      hls.style.alignItems = toVAlign(rowAlign.getTag());
      var div = document.createElement('div');
      div.classList.add("ux-HyperlinkListSelector-content");
      var isVirtual = comp.getType().is('baja:VirtualComponent');
      var linkNames = [],
          linkOrds = [],
          hyperlinks = [],
          external = [];
      var numberOfLinks = comp.get('numberOfHyperlinks');

      for (var i = 0; i < numberOfLinks; i++) {
        linkNames[i] = comp.get('hyperlinkDisplay' + (i + 1));
        linkOrds[i] = comp.get('hyperlinkOrd' + (i + 1)); // check if external slot exists to handle backward compatibility

        // check if external slot exists to handle backward compatibility
        external[i] = comp.get('external' + (i + 1));
        if (external[i] == null) external[i] = false;

        if (isVirtual === true && external[i] === false) {
          // TODO resolve ord via virtual gateway without NiagaraVirtualUtil support
          // NiagaraVirtualUtil.fromServerOrdToClientVirtual(BOrd.make("slot:/"),ord));
          var vord = linkOrds[i].encodeToString();
          var index = vord.indexOf("station:");

          if (index > -1) {
            vord = vord.substring(index + 9);
          }

          hyperlinks[i] = baja.Ord.make({
            base: comp.getComponentSpace().getNavOrd().relativizeToSession(),
            child: vord
          }).toUri();
        } else if (external[i] === false) {
          hyperlinks[i] = baja.Ord.make({
            base: profileUtils.getCurrentOrd().relativizeToSession(),
            child: linkOrds[i].normalize()
          }).toUri();
        } else {
          // this is an external link so don't modify
          hyperlinks[i] = linkOrds[i];
        }
      }

      var selectorSpan = document.createElement('select');
      selectorSpan.classList.add('-v-Selector');
      font.applyToElement(selectorSpan);
      selectorSpan.add(new Option(selectionText));

      for (var j = 0; j < numberOfLinks; j++) {
        selectorSpan.add(new Option(linkNames[j], hyperlinks[j]));
      }

      return [{
        dom: div,
        kids: [{
          dom: selectorSpan
        }]
      }];
    });
  }));
  /**
   * Horizontal positioning based on css changes to `justifyContent`
   * @param {String} tag
   * @return {String}
   */

  function toHAlign(tag) {
    switch (tag) {
      case 'center':
      case 'fill':
        return 'center';

      case 'left':
        return 'flex-start';

      case 'right':
        return 'flex-end';
    }
  }
  /**
   * Vertical position based on css change to `alignItems`.
   * @param {String} tag
   * @return {String}
   */


  function toVAlign(tag) {
    switch (tag) {
      case 'fill':
      case 'center':
        return 'center';

      case 'top':
        return 'flex-start';

      case 'bottom':
        return 'flex-end';
    }
  }

  function hyper(hyperlink, widget) {
    var browserTarget = widget.properties().getValue('browserTarget');

    if (browserTarget === "_self" || browserTarget === "_parent") {
      return Promise["try"](function () {
        return niagara.env.hyperlink(hyperlink);
      })["catch"](logSevere);
    } else {
      window.open(hyperlink, browserTarget);
    }
  }

  ;
});
