function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Copyright 2021 Tridium, Inc. All Rights Reserved.
 */

/** @jsx spandrel.jsx */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/RotationOrderEditor
 */
define(['baja!', 'baja!gx:Font', 'bajaux/spandrel', 'bajaux/mixin/subscriberMixIn', 'bajaux/util/CommandButton', 'nmodule/webEditors/rc/fe/baja/StringEditor', 'nmodule/webEditors/rc/wb/commands/ReorderSlotsCommand', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, types, spandrel, subscriberMixIn, CommandButton, StringEditor, ReorderSlotsCommand) {
  'use strict';

  var widgetDefaults = function widgetDefaults() {
    return {
      properties: {
        font: {
          value: baja.$('gx:Font', 'null').encodeToString(),
          typeSpec: 'gx:Font'
        }
      }
    };
  };

  return /*#__PURE__*/function (_spandrel) {
    _inherits(RotationOrderEditor, _spandrel);

    var _super = _createSuper(RotationOrderEditor);

    function RotationOrderEditor(params) {
      var _this;

      _classCallCheck(this, RotationOrderEditor);

      _this = _super.call(this, {
        params: params,
        defaults: widgetDefaults()
      });
      subscriberMixIn(_assertThisInitialized(_this));
      _this.$subscriber = new baja.Subscriber();

      _this.$subscriber.attach('changed', function (prop) {
        if (prop.getName() === 'order') {
          _this.rerender();
        }
      });

      return _this;
    }

    return RotationOrderEditor;
  }(spandrel(function (rotationOrder, _ref) {
    var properties = _ref.properties;
    var font = properties.font;
    var fontValue = baja.$('gx:Font').decodeFromString(font);
    var str = rotationOrder.get('order');
    var cmd = new ReorderSlotsCommand(rotationOrder);
    return cmd.loading().then(function () {
      cmd.setDisplayNameFormat('%lexicon(vykonPro:commands.reorder.label)%');
      cmd.setEnabled(true);
      return [spandrel.jsx(StringEditor, {
        $init: function $init(el) {
          return fontValue.applyToElement(el);
        },
        tagName: "span",
        value: str,
        readonly: true
      }), spandrel.jsx(CommandButton, {
        $init: function $init(el) {
          return fontValue.applyToElement(el);
        },
        className: "ux-RotationOrder",
        tagName: "span",
        value: cmd
      })];
    });
  }));
});
