function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } else if (call !== void 0) { throw new TypeError("Derived constructors may only return object or undefined"); } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

/**
 * Copyright 2021 Tridium, Inc. All Rights Reserved.
 */

/* jshint browser: true */

/* eslint-env browser */

/* global niagara */

/**
 * API Status: **Private**
 * @module nmodule/vykonPro/rc/binding/EnhancedHyperlinkBinding
 */
define(['baja!', 'nmodule/bajaui/rc/baja/binding/Binding', 'nmodule/bajaui/rc/binding/impl/widgetEvents', 'Promise', 'log!uxMedia', 'css!nmodule/vykonPro/rc/vykonPro'], function (baja, Binding, widgetEvents, Promise, log) {
  'use strict';

  var logSevere = log.severe.bind(log);
  /**
   * BajaScript implementation of a `vykonPro:EnhancedHyperlinkBinding`.
   * @class
   * @alias module:nmodule/vykonPro/rc/binding/EnhancedHyperlinkBinding
   * @extends module:nmodule/bajaui/rc/baja/binding/Binding
   */

  return /*#__PURE__*/function (_Binding) {
    _inherits(EnhancedHyperlinkBinding, _Binding);

    var _super = _createSuper(EnhancedHyperlinkBinding);

    function EnhancedHyperlinkBinding() {
      _classCallCheck(this, EnhancedHyperlinkBinding);

      return _super.apply(this, arguments);
    }

    _createClass(EnhancedHyperlinkBinding, [{
      key: "addListeners",
      value:
      /**
       * Add event listeners for the widget:
       *
       * - on click, popup
       * - add CSS to indicate cursor
       *
       * @param {module:bajaux/Widget} widget
       */
      function addListeners(widget) {
        var _this = this;

        this.addWidgetEvents(widget, {
          click: function click(e) {
            var ord = _this.get('ord');

            if (ord.isNull()) {
              return;
            }

            return _this.$formatHyperlink().then(function (hyperlink) {
              var url = hyperlink.toUri();

              var target = _this.get('browserTarget');

              if (target === "_self" || target === "_parent") {
                e.preventDefault();
                return Promise["try"](function () {
                  return niagara.env.hyperlink(hyperlink);
                })["catch"](logSevere);
              } else {
                window.open(url, target);
              }
            });
          },
          initialized: function initialized() {
            var ord = _this.get('ord');

            widget.jq().addClass('ux-EnhancedHyperlinkBinding').toggleClass('hyperlink-target', !ord.isNull());
          },
          destroyed: function destroyed() {
            widget.jq().removeClass('ux-EnhancedPopupBinding hyperlink-target');
          }
        });
      }
      /*
      * resolve hyperlinkFormat against ord to determine hyperlink URL
      */

    }, {
      key: "$formatHyperlink",
      value: function $formatHyperlink() {
        return this.get('hyperlinkFormat').format({
          object: this.getOrdTarget().getObject()
        }) //.then(baja.Ord.make);
        .then(function (value) {
          return baja.Ord.make({
            base: "station:",
            child: value
          });
        });
      }
    }]);

    return EnhancedHyperlinkBinding;
  }(Binding);
});
